namespace eval [ref Contact]::meta {
	array set translit {
		type boolean default 0 save change menu Transliterate
	}
}

set forward "\u430 a \u431 b \u432 v \u433 g \u434 d \u437 z \u438 i \u439 j \u43a k \u43b l \u43c m \u43d n \u43e o \u43f p \u440 r \u441 s \u442 t \u443 u \u444 f \u445 h \u44a ' \u44b y \u44c ' \u44d e \u44e ju \u44f ja \u435 je \u451 jo \u436 zh \u446 ts \u447 ch \u448 sh \u449 shch"

set extra "ya \u44f yo \u451 yu \u44e ye \u435"

foreach a $forward { lappend forward [string totitle $a] }
foreach a $extra { lappend extra [string totitle $a] }
set backward [list]
foreach a $forward { set backward [concat $a $backward] }
set backward [concat $extra $backward]

proc allowed {uid} {
	set var [ref $uid](translit)
	expr {[info exists $var] && [string is true [set $var]]}
}

proc translit {direction uid text} {
	if {![allowed $uid]} { return $text }
	variable $direction
	string map [set $direction] $text
}

filter Send TranslitForward {type uid message} {
	if {$type=="text"} { set message [translit forward $uid $message] }
	list $type $uid $message
} 0.8

filter Incoming TranslitBackward {type uid time message id} {
	if {$type=="text"} { set message [translit backward $uid $message] }
	list $type $uid $time $message $id
} 0.1

